using System;

namespace mmh_ccx2vtk
{
	public partial class Program
	{

		//INFORMATIVE TEXTS
		private static string TXT0000 = "*** CalculiX output file \".frd\" to vtk format converter by Maciej Marek Hawrylkiewicz mamah@wp.pl ***";

		private static string TXT0001 = ": Running on ";
		private static string TXT0002 = ": Read argument: ";
		private static string TXT0003 = ": Opening input file: \"{0}\"";
		private static string TXT0004 = ": Nodes read: {0}";
		private static string TXT0005 = ": Elements read: {0}";
		private static string TXT0006 = ": Reading result data from step: {0}";
		private static string TXT0007 = ": Nodal results block found:'{0}', defined number of result lines: {1}, defined number of items: {2}";
		private static string TXT0008 = ": Read {0} results lines in block: {1}";
		private static string TXT0009 = ": Read total number of steps: {0}";
		private static string TXT0010 = ": Writing new file: {0}";

		private static string TXT9999 = ": press Enter...";

		//ERROR MESSAGES
		private static string ERTXT0000 = "! (00) argument not found...";
		private static string ERTXT0001 = "! (01) Unexpected extension in file name \"{0}\", should be \".frd\"";
		private static string ERTXT0002 = "! (02) File not found...";

		private static string ERTXT0010 = "! (10) Cannot read the number of nodes in text \"{0}\",  in line: {1}";
		private static string ERTXT0011 = "! (11) Cannot read node data in line: {0}";
		private static string ERTXT0012 = "! (12) Declared number of nodes {0} is different than read node lines {1}";
		private static string ERTXT0013 = "! (13) Unexpected line code, in nodes block in line: {0}\"";
		private static string ERTXT0014 = "! (14) Cannot read element node number, in line: {0}";

		private static string ERTXT0020 = "! (20) Cannot read the number of elements in text \"{0}\",  in line: {1}";
		private static string ERTXT0021 = "! (21) Cannot read element node number, in line: {0}";
		private static string ERTXT0022 = "! (22) Unsupported element type in line: {0}";
		private static string ERTXT0023 = "! (23) Declared number of elements {0} is different than read element lines: {1}";
		private static string ERTXT0024 = "! (24) Unexpected line code in elements block, in line {0}";
		private static string ERTXT0025 = "! (25) The number of nodes numbers doesn't pass the element type, in line: {0}";

		private static string ERTXT0030 = "! (30) Cannot read the data block info in line {0}";
		private static string ERTXT0031 = "! (31) Can not read the dataset NAME or NUMBER of entities in line: {0}";
		private static string ERTXT0032 = "! (32) Can not read the dataset the entity NAME in line: {0}";
		private static string ERTXT0033 = "! (33) Can not read the results in line: {0}";
		private static string ERTXT0034 = "! (34) The number of read result lines {0} is different than declared number: {1}";

		private static void PrintHelp() {
			Console.WriteLine (":  ");
			Console.WriteLine (":  Usage:");
			Console.WriteLine (":  ");
			Console.WriteLine (":  mmh_ccx2vtk.exe [path]CalculiXoutputFileName.frd");
			Console.WriteLine (":  ");
			Console.WriteLine (":  The [path] string is optional, if not provided assembly will");
			Console.WriteLine (":  try to open specified \"frd\" file in current directory.");
			Console.WriteLine (":  ");
			Console.WriteLine (":  After succesful conversion the new file will be created using input file name ");
			Console.WriteLine (":  with suffix: \"_mmh.vtk\" in the input directory");
			Console.WriteLine (":  ");
			Console.WriteLine (":  Conversion supports all CalculiX element types and defined number of steps.");
			Console.WriteLine (":  The vector results are transalated as vectors, any other data are treat as scalar");
			Console.WriteLine (":  The name of Nodal Result Block in 'vtk' file and displayed in ParaView is as:");
			//Console.WriteLine (":      '[stepn_number]-block_name-item_name' where:");
			Console.WriteLine (":      'StepNumber_Blockname_ItemName' where:");
			Console.WriteLine (":  ");
//			Console.WriteLine (":            'step_number' is the user step number,");
//			Console.WriteLine (":            'block_name' is the name i.e. \"DISPR\"");
//			Console.WriteLine (":            'item_name' is the item name i.e. \"D1\"");
			Console.WriteLine (":            'StepNumber' is the user step number,");
			Console.WriteLine (":            'BlockName' is the name i.e. \"DISPR\"");
			Console.WriteLine (":            'ItemName' is the item name i.e. \"D1\"");
			Console.WriteLine (":  ");
			Console.WriteLine (":  It is the .NET/MONO assembly and it should work properly in Linux/Windows environment.");
			Console.WriteLine (":  ");
//			Console.WriteLine (":  Please inform me about bugs on mail: mamah@wp.pl");
			Console.WriteLine (":  ");
			Console.WriteLine (";) Have a nice step!");
			Console.WriteLine (":  ");
			Console.WriteLine (":  <<<MMH>>>");
			Console.WriteLine (":  ");
		}

	}
}

