using System;

namespace mmh_ccx2vtk
{
	public partial class Program
	{
	
		private static double FodX(double A, double B, double C, double x) {
			return x * x * x - A * x * x + B * x - C;
		}

		private static bool Poly3Root(double xa, double xb, double A, double B, double C, ref double x) {
			//x^3 - A * x^2 + B * x - C = 0
			bool result = false;

			double ya = FodX(A, B, C, xa);
			double yb = FodX(A, B, C, xb);

			double xc, yc;

			double D = 1e-6;

			if (Math.Abs (ya) < D) {
				result = true;
				x = xa;
			} else if (Math.Abs (yb) < D) {
				result = true;
				x = xb;
			} else if (ya > 0 && yb < 0 || ya < 0 && yb > 0) {
			
				for (;;) {

					xc = (xa + xb) / 2;
					yc = FodX (A, B, C, xc);

					if (Math.Abs (xb - xa) < D) {
						result = true;
						x = xc;
						break; 
					}

					if (ya < 0 && yc > 0 || ya > 0 && yc < 0) {
						xb = xc; yb = yc;
					} else {
						xa = xc; ya = yc;
					}

				}
			}
			return result;
		}


	}
}

