
using System;
using System.Collections.Generic; 

namespace mmh_ccx2vtk
{
	public partial class Program
	{
		//node
		private struct tNode
		{
			public double X;
			public double Y;
			public double Z;
			public int vtk_nr;
			public bool IsFirst; //for element type 5-ccx 15 node wedge which seems to be not supported in VTK
		}

		//element
		private struct tElement
		{
			public int NR;
			public int TYP;
			public int[] N;
		}

		//the dictionary is really required here
		private struct tNodResBlRec {
			public double[] Data;
		}

		//Nodal Result Block
		private struct tNodResBlock {
			public int StepN; //step number
            public double StepT; //step time
			public string Name; //name i.e. STRESSR
			public int Count; //number of lines with values
			public int DeclNumOfItems; //declared number of items
			public int NumOfItems; //as above but reduced when there are items supposed to be automatically calculated by cgx and there is no values in frd file
			public string[] ItemNameTab; //names of items (even with automated names i.e. 'ALL')
			public Dictionary<int, tNodResBlRec> DICT; //lines of values

			public tNodResBlock(string BlName, int TotNum, int ItNum, int StNum, double StTim) {
				this.StepN = StNum;
                this.StepT = StTim;
				this.Name = BlName;
				this.Count = TotNum;
				this.DeclNumOfItems = ItNum;
				this.NumOfItems = ItNum;
				this.ItemNameTab = new string[ItNum];
				this.DICT = new Dictionary<int, tNodResBlRec> (TotNum);
			}
		}

		//------------ data containers ------------------------------------------------------
		private static Dictionary<int, tNode> NodeTab;
		private static tElement[] ElementTab;
		//result data blocks container
		private static List<tNodResBlock> DataTab;
		//------------------------------------------------------------------------------------

	}
}

